#include <stdio.h>

#include <zephyr/shell/shell.h>

static int cmd_print_handler(const struct shell *sh, size_t argc, char **argv)
{
    shell_print(sh, "Received %d arguments:", argc);
	printf("Received %d arguments:\n", argc);
    for (size_t i = 0; i < argc; i++) {
        shell_print(sh, "  argv[%d]: %s", i, argv[i]);
		printf("  argv[%d]: %s", i, argv[i]);
    }
    return 0;
}

SHELL_CMD_REGISTER(print, NULL, "Print received arguments", cmd_print_handler);

// void trigger_shell_command_directly(void)
// {
//     const struct shell *sh = shell_backend_uart_get_ptr();
//     char *args[] = {"print", "Hello", "World"};
//     size_t argc = 3;

//     // Directly invoke the shell command handler
//     cmd_print_handler(sh, argc, args);
// }

int main(void)
{
	printf("Hello World! %s\n", CONFIG_BOARD);

	const struct shell *sh = shell_backend_uart_get_ptr();  // Shell pointer

	while (!shell_ready(sh)) {
        k_sleep(K_MSEC(100));  // Wait until the shell is ready
    }

	// trigger_shell_command_directly();

	while(1)
	{
		shell_print(sh, "print from52");
		//shell_print(sh, "print from91");
		k_sleep(K_MSEC(2000));
	}

	return 0;
}
